import { IBotProvider, IBotProviderMessageCtx } from '@lskjs/bots-base/types';
import { BaseBotPlugin } from '@lskjs/bots-plugin';
export declare class DebugBotPlugin extends BaseBotPlugin {
    setStartParams(bot: IBotProvider, user: any, ctx: IBotProviderMessageCtx): Promise<void>;
    runBot(bot: IBotProvider, name: string): Promise<void>;
    runPing(bot: IBotProvider): Promise<void>;
    runChatId(bot: IBotProvider, name: string): Promise<void>;
    runLogger(bot: IBotProvider, name: string): Promise<void>;
    /**
     * Вешает обработчик который слушает команды на реплаи к сообщениям.
     *
     * Если команда совпадет со белым списком ('link', 'линк', 'ссылку')
     * то бот пытается сгенерить ссылку на реплайнутое сообщение и удалить
     * сообщение которое его стриггерило.
     *
     * @param bot
     */
    runLink(bot: IBotProvider): Promise<void>;
}
export default DebugBotPlugin;
