"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DebugBotPlugin = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _privateLinker = require("@lskjs/bots-base/utils/private-linker");
var _botsPlugin = require("@lskjs/bots-plugin");
var _err = _interopRequireDefault(require("@lskjs/err"));
var _bluebird = _interopRequireDefault(require("bluebird"));
var _chunk = _interopRequireDefault(require("lodash/chunk"));
var _fromPairs = _interopRequireDefault(require("lodash/fromPairs"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, defineProperty = Object.defineProperty || function (obj, key, desc) { obj[key] = desc.value; }, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return defineProperty(generator, "_invoke", { value: makeInvokeMethod(innerFn, self, context) }), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; defineProperty(this, "_invoke", { value: function value(method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return doneResult(); } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; } function maybeInvokeDelegate(delegate, context) { var methodName = context.method, method = delegate.iterator[methodName]; if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator["return"] && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel; var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) { if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; } return next.value = undefined, next.done = !0, next; }; return next.next = next; } } return { next: doneResult }; } function doneResult() { return { value: undefined, done: !0 }; } return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), defineProperty(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (val) { var object = Object(val), keys = []; for (var key in object) { keys.push(key); } return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) { "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); } }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, "catch": function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DebugBotPlugin = /*#__PURE__*/function (_BaseBotPlugin) {
  (0, _inherits2["default"])(DebugBotPlugin, _BaseBotPlugin);
  var _super = _createSuper(DebugBotPlugin);
  function DebugBotPlugin() {
    (0, _classCallCheck2["default"])(this, DebugBotPlugin);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(DebugBotPlugin, [{
    key: "setStartParams",
    value: function () {
      var _setStartParams = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(bot, user, ctx) {
        var text, _text$split, _text$split2, command, key, props, locale, data;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // link example:
                // https://telegram.me/bot_username?start=startPayload-key1_value_key2_value
                text = bot.getMessageText(ctx);
                if (text) {
                  _context.next = 3;
                  break;
                }
                return _context.abrupt("return");
              case 3:
                _text$split = text.split(/\s|-|_/), _text$split2 = (0, _toArray2["default"])(_text$split), command = _text$split2[0], key = _text$split2[1], props = _text$split2.slice(2);
                if (!(command !== '/start' || key !== 'startPayload')) {
                  _context.next = 6;
                  break;
                }
                return _context.abrupt("return");
              case 6:
                locale = ctx.from.language_code;
                data = (0, _fromPairs["default"])((0, _chunk["default"])(props, 2));
                user.setRef(data);
                user.setLang(data, locale);
                _context.next = 12;
                return user.save();
              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      function setStartParams(_x, _x2, _x3) {
        return _setStartParams.apply(this, arguments);
      }
      return setStartParams;
    }()
  }, {
    key: "runBot",
    value: function () {
      var _runBot = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(bot, name) {
        var _this$config, _this$config2, _this$config3, _this$config4;
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (this.app) {
                  _context2.next = 2;
                  break;
                }
                throw new _err["default"]('!app');
              case 2:
                if (!(((_this$config = this.config) === null || _this$config === void 0 ? void 0 : _this$config.logger) !== false)) {
                  _context2.next = 5;
                  break;
                }
                _context2.next = 5;
                return this.runLogger(bot, name);
              case 5:
                if (!(((_this$config2 = this.config) === null || _this$config2 === void 0 ? void 0 : _this$config2.ping) !== false)) {
                  _context2.next = 8;
                  break;
                }
                _context2.next = 8;
                return this.runPing(bot);
              case 8:
                if (!(((_this$config3 = this.config) === null || _this$config3 === void 0 ? void 0 : _this$config3.chat) !== false)) {
                  _context2.next = 11;
                  break;
                }
                _context2.next = 11;
                return this.runChatId(bot, name);
              case 11:
                if (!(((_this$config4 = this.config) === null || _this$config4 === void 0 ? void 0 : _this$config4.link) !== false)) {
                  _context2.next = 14;
                  break;
                }
                _context2.next = 14;
                return this.runLink(bot);
              case 14:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));
      function runBot(_x4, _x5) {
        return _runBot.apply(this, arguments);
      }
      return runBot;
    }()
  }, {
    key: "runPing",
    value: function () {
      var _runPing = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(bot) {
        var _this = this;
        return _regeneratorRuntime().wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                bot.on('message', /*#__PURE__*/function () {
                  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(ctx) {
                    var ms, v, text;
                    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            if (!bot.isMessageCommand(ctx, 'kill')) {
                              _context3.next = 7;
                              break;
                            }
                            _this.log.error('KILL FORM USER', bot.getMessageUserId(ctx));
                            bot.reply(ctx, '[ok]');
                            _context3.next = 5;
                            return _bluebird["default"].delay(1000);
                          case 5:
                            process.exit(1);
                            return _context3.abrupt("return", null);
                          case 7:
                            if (!bot.isMessageCommand(ctx, 'ping')) {
                              _context3.next = 10;
                              break;
                            }
                            ms = Math.floor((Date.now() / 1000 - ctx.message.date) * 1000);
                            return _context3.abrupt("return", bot.reply(ctx, "[pong] ".concat(ms, "ms")));
                          case 10:
                            if (!bot.isMessageCommands(ctx, ['v', 'powered', 'poweredby'])) {
                              _context3.next = 15;
                              break;
                            }
                            if (!_this.botsModule) _this.log.warn('!botsModule');
                            v = _this.botsModule.v || 0;
                            text = "\n*BotKit* `v".concat(v, "` \nPowerful starter kit for bot development on Telegram, Discord, Instagram, Twitter, Facebook, WhatsApp, Vkontakte\n\nDo you want bot? Ask @isuvorov\n\u041C\u043E\u0436\u0435\u043C \u0441\u0434\u0435\u043B\u0430\u0442\u044C \u0442\u0435\u0431\u0435 \u0442\u0430\u043A\u043E\u0433\u043E \u0436\u0435, \u043F\u0438\u0448\u0438 \uD83D\uDE09\n\nDocs: [@lskjs/lskjs](https://github.com/lskjs/lskjs)\nNpm: [@lskjs/bots](https://npmjs.com/package/@lskjs/bots)\nAny question: @lskjschat\n\nMade on @LSKjs with \u2764\uFE0F");
                            return _context3.abrupt("return", bot.reply(ctx, text, {
                              parse_mode: 'MarkdownV2'
                            }));
                          case 15:
                            return _context3.abrupt("return", null);
                          case 16:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));
                  return function (_x7) {
                    return _ref.apply(this, arguments);
                  };
                }());
              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));
      function runPing(_x6) {
        return _runPing.apply(this, arguments);
      }
      return runPing;
    }() // eslint-disable-next-line @typescript-eslint/no-unused-vars
  }, {
    key: "runChatId",
    value: function () {
      var _runChatId = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(bot, name) {
        return _regeneratorRuntime().wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                bot.on('message', function (ctx) {
                  if (!bot.isMessageCommands(ctx, ['id', 'ид', 'chatid', 'чат'])) return;
                  if (bot.provider === 'vk') {
                    ctx.reply(ctx.message.reply_message ? ctx.message.reply_message.from_id : ctx.message.from_id);
                  }
                  if (bot.provider === 'telegram') {
                    var renderMessage = function renderMessage(message) {
                      return "id: `".concat(message.message_id, "` [").concat(bot.getMessageType(message), "]");
                    };
                    var renderChat = function renderChat(chat) {
                      return "chatId: `".concat(chat.id, "` ").concat(chat.type === 'supergroup' ? '[supergroup]' : '');
                    }; // [${chat.title}]
                    var renderUser = function renderUser(from) {
                      return "userId: `".concat(from.id, "` ").concat(from.is_bot ? '[bot]' : '');
                    };
                    var text = ['*Message*', renderMessage(ctx.message), ctx.message.from && renderUser(ctx.message.from), ctx.message.chat && renderChat(ctx.message.chat), ctx.message.reply_to_message && '\n*Replied message*', ctx.message.reply_to_message && renderMessage(ctx.message.reply_to_message), ctx.message.reply_to_message && ctx.message.reply_to_message.from && renderUser(ctx.message.reply_to_message.from), ctx.message.reply_to_message && ctx.message.reply_to_message.forward_from && '\n*Forwarded user*', ctx.message.reply_to_message && ctx.message.reply_to_message.forward_from && renderUser(ctx.message.reply_to_message.forward_from)].filter(Boolean).join('\n');
                    bot.reply(ctx, text, {
                      parse_mode: 'MarkdownV2'
                    });
                  }
                });
              case 1:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));
      function runChatId(_x8, _x9) {
        return _runChatId.apply(this, arguments);
      }
      return runChatId;
    }()
  }, {
    key: "runLogger",
    value: function () {
      var _runLogger = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(bot, name) {
        var _this2 = this;
        var BotsEventModel, BotsTelegramMessageModel, BotsTelegramUserModel, BotsTelegramChatModel, provider;
        return _regeneratorRuntime().wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.botsModule.module('models.BotsEventModel');
              case 2:
                BotsEventModel = _context7.sent;
                _context7.next = 5;
                return this.botsModule.module('models.BotsTelegramMessageModel');
              case 5:
                BotsTelegramMessageModel = _context7.sent;
                _context7.next = 8;
                return this.botsModule.module('models.BotsTelegramUserModel');
              case 8:
                BotsTelegramUserModel = _context7.sent;
                _context7.next = 11;
                return this.botsModule.module('models.BotsTelegramChatModel');
              case 11:
                BotsTelegramChatModel = _context7.sent;
                provider = bot.provider;
                bot.eventTypes.forEach(function (type) {
                  bot.on(type, /*#__PURE__*/function () {
                    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(ctx) {
                      var eventData, _this2$config, messageType, _eventData, sender_chat, chat, chatUserId, id, _yield$BotsTelegramCh, _this2$config2, _messageType, _eventData2, from, _chat, user, telegramUserId, _chatUserId, _id, _yield$BotsTelegramCh2;
                      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
                        while (1) {
                          switch (_context6.prev = _context6.next) {
                            case 0:
                              if (!(provider === 'telegram' && type === 'callback_query')) {
                                _context6.next = 5;
                                break;
                              }
                              eventData = ctx.update.callback_query;
                              _this2.log.trace("<".concat(_this2.name, "/").concat(name, "> [").concat(type, "]"), eventData);
                              _context6.next = 47;
                              break;
                            case 5:
                              if (!(provider === 'telegram' && type === 'channel_post')) {
                                _context6.next = 22;
                                break;
                              }
                              eventData = ctx.update.channel_post;
                              _this2.log.trace("<".concat(_this2.name, "/").concat(name, "> [").concat(type, "]"), eventData);
                              if (!(((_this2$config = _this2.config) === null || _this2$config === void 0 ? void 0 : _this2$config.save) === false)) {
                                _context6.next = 10;
                                break;
                              }
                              return _context6.abrupt("return");
                            case 10:
                              messageType = bot.getMessageType(ctx);
                              _eventData = eventData, sender_chat = _eventData.sender_chat, chat = _eventData.chat;
                              if (!(chat && chat.id < 0)) {
                                _context6.next = 18;
                                break;
                              }
                              id = chat.id;
                              _context6.next = 16;
                              return BotsTelegramChatModel.findOneAndUpdate({
                                id: id
                              }, {
                                id: id
                              }, {
                                "new": true,
                                upsert: true
                              });
                            case 16:
                              _yield$BotsTelegramCh = _context6.sent;
                              chatUserId = _yield$BotsTelegramCh._id;
                            case 18:
                              _context6.next = 20;
                              return BotsTelegramMessageModel.create(_objectSpread({
                                botId: bot.getBotId(),
                                sender_chat: sender_chat,
                                chatUserId: chatUserId,
                                type: messageType
                              }, eventData));
                            case 20:
                              _context6.next = 47;
                              break;
                            case 22:
                              if (!(provider === 'telegram' && type === 'message')) {
                                _context6.next = 45;
                                break;
                              }
                              eventData = ctx.message;
                              _this2.log.trace("<".concat(_this2.name, "/").concat(name, "> [").concat(type, "]"), eventData);
                              if (!(((_this2$config2 = _this2.config) === null || _this2$config2 === void 0 ? void 0 : _this2$config2.save) === false)) {
                                _context6.next = 27;
                                break;
                              }
                              return _context6.abrupt("return");
                            case 27:
                              // Don't wait
                              _messageType = bot.getMessageType(ctx);
                              _eventData2 = eventData, from = _eventData2.from, _chat = _eventData2.chat;
                              _context6.next = 31;
                              return BotsTelegramUserModel.findOneAndUpdate({
                                id: from.id
                              }, from, {
                                "new": true,
                                upsert: true
                              });
                            case 31:
                              user = _context6.sent;
                              telegramUserId = user._id;
                              _context6.next = 35;
                              return _this2.setStartParams(bot, user, ctx);
                            case 35:
                              if (!(_chat && _chat.id < 0)) {
                                _context6.next = 41;
                                break;
                              }
                              _id = _chat.id;
                              _context6.next = 39;
                              return BotsTelegramChatModel.findOneAndUpdate({
                                id: _id
                              }, {
                                from: from,
                                id: _id
                              }, {
                                "new": true,
                                upsert: true
                              });
                            case 39:
                              _yield$BotsTelegramCh2 = _context6.sent;
                              _chatUserId = _yield$BotsTelegramCh2._id;
                            case 41:
                              _context6.next = 43;
                              return BotsTelegramMessageModel.create(_objectSpread({
                                botId: bot.getBotId(),
                                telegramUserId: telegramUserId,
                                chatUserId: _chatUserId,
                                type: _messageType
                              }, eventData));
                            case 43:
                              _context6.next = 47;
                              break;
                            case 45:
                              _this2.log.warn("<".concat(_this2.name, "/").concat(name, "> [").concat(provider, "/").concat(type, "] LOGGER NOT IMPLEMENTED"));
                              if (_this2.debug) _this2.log.trace('[CTX]', ctx);
                            case 47:
                              _context6.next = 49;
                              return BotsEventModel.create({
                                botId: bot.getBotId(),
                                provider: bot.provider,
                                type: type,
                                data: eventData
                              });
                            case 49:
                            case "end":
                              return _context6.stop();
                          }
                        }
                      }, _callee6);
                    }));
                    return function (_x12) {
                      return _ref2.apply(this, arguments);
                    };
                  }());
                });
              case 14:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));
      function runLogger(_x10, _x11) {
        return _runLogger.apply(this, arguments);
      }
      return runLogger;
    }()
    /**
     * Вешает обработчик который слушает команды на реплаи к сообщениям.
     *
     * Если команда совпадет со белым списком ('link', 'линк', 'ссылку')
     * то бот пытается сгенерить ссылку на реплайнутое сообщение и удалить
     * сообщение которое его стриггерило.
     *
     * @param bot
     */
  }, {
    key: "runLink",
    value: function () {
      var _runLink = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(bot) {
        return _regeneratorRuntime().wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                bot.on('message', /*#__PURE__*/function () {
                  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(ctx) {
                    var chatId, removeMessageId, messageId, text;
                    return _regeneratorRuntime().wrap(function _callee8$(_context8) {
                      while (1) {
                        switch (_context8.prev = _context8.next) {
                          case 0:
                            if (bot.isMessageCommands(ctx, ['link', 'линк', 'ссылку'])) {
                              _context8.next = 2;
                              break;
                            }
                            return _context8.abrupt("return");
                          case 2:
                            chatId = bot.getMessageChatId(ctx);
                            removeMessageId = bot.getMessageId(ctx);
                            if (chatId) {
                              _context8.next = 6;
                              break;
                            }
                            throw new _err["default"]('!chatId');
                          case 6:
                            if (removeMessageId) {
                              _context8.next = 8;
                              break;
                            }
                            throw new _err["default"]('!removeMessageId');
                          case 8:
                            messageId = bot.getRepliedMessageId(ctx);
                            if (!messageId) {
                              messageId = removeMessageId;
                              removeMessageId = null;
                            }
                            text = (0, _privateLinker.getPrivateLinkToMessage)({
                              chatId: chatId,
                              messageId: messageId
                            });
                            _context8.next = 13;
                            return bot.reply(ctx, text);
                          case 13:
                            if (!removeMessageId) {
                              _context8.next = 16;
                              break;
                            }
                            _context8.next = 16;
                            return ctx.deleteMessage(removeMessageId);
                          case 16:
                          case "end":
                            return _context8.stop();
                        }
                      }
                    }, _callee8);
                  }));
                  return function (_x14) {
                    return _ref3.apply(this, arguments);
                  };
                }());
              case 1:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));
      function runLink(_x13) {
        return _runLink.apply(this, arguments);
      }
      return runLink;
    }()
  }]);
  return DebugBotPlugin;
}(_botsPlugin.BaseBotPlugin);
exports.DebugBotPlugin = DebugBotPlugin;
var _default = DebugBotPlugin;
exports["default"] = _default;
//# sourceMappingURL=DebugBotPlugin.js.map